//------------DOMLOAD		
document.addEventListener("DOMContentLoaded", function () {
	//console.log("DOM loaded");
	//detect Android and iOs and add class to html tag
	var classNames = [];
	if (navigator.userAgent.match(/(iPad|iPhone|iPod)/i)) classNames.push('device-ios');
	if (navigator.userAgent.match(/android/i)) classNames.push('device-android');
	var html = document.getElementsByTagName('html')[0];
	if (classNames.length) classNames.push('on-device');
	if (html.classList) html.classList.add.apply(html.classList, classNames);
		
	//add controls to video (for Android strange bug)
	if(isMobile.Android()){
		var videos = document.querySelectorAll('video');
		videos.forEach(function(video){
			video.setAttribute('controls', '');
		});
	}
	
	//animation and transion end event
	function whichAnimationEvent(){
		var t,
		el = document.createElement("fakeelement");
		var animations = {
			"animation"      : "animationend",
			"OAnimation"     : "oAnimationEnd",
			"MozAnimation"   : "animationend",
			"WebkitAnimation": "webkitAnimationEnd"
		}
		for (t in animations){
			if (el.style[t] !== undefined){
				return animations[t];
			}
		}
	}
	var animationEvent = whichAnimationEvent();

	function whichTransitionEvent(){
		var t,
		el = document.createElement("fakeelement");
		var transitions = {
			"transition"      : "transitionend",
			"OTransition"     : "oTransitionEnd",
			"MozTransition"   : "transitionend",
			"WebkitTransition": "webkitTransitionEnd"
		}
		for (t in transitions){
			if (el.style[t] !== undefined){
				return transitions[t];
			}
		}
	}
	var transitionEvent = whichTransitionEvent();
	
	//pointer-events for old IE < 11
	var pointerEventsMask = function(){
		if(navigator.appName == 'Microsoft Internet Explorer'){
			var agent = navigator.userAgent;
			if (agent.match(/MSIE ([0-9]{1,}[\.0-9]{0,})/) != null){
				var version = parseFloat( RegExp.$1 );
				if(version < 11){
					var noEvents = document.querySelectorAll('.no-event')
					noEvents.forEach(function(elt){
						elt.addEventListener('mousedown', function(e){
							this.style.display = 'none';
							var BottomElement = document.elementFromPoint(e.clientX, e.clientY);
							this.style.display = '';
							triggerEvent(BottomElement, 'click'); //Manually fire the event for desired underlying element
							return false;
						})
					});
				}
			}
		}
	}
	
	//object-fit ruse for IE and Edge or any navigator that doesn't understand object-fit
	//var isSafari = (navigator.userAgent.toLowerCase().indexOf('safari/') > -1 && navigator.userAgent.toLowerCase().indexOf('chrome/') < 0);
	if('objectFit' in document.documentElement.style === false) {
		var liste = document.querySelectorAll('.js-object-fit');
		liste.forEach(function(elt){
			var imgUrl = elt.querySelector('img').getAttribute('src');
			if (imgUrl) {
				elt.style.backgroundImage = 'url(' + imgUrl + ')';
				elt.style.backgroundPosition = (elt.getAttribute('data-bg-pos')) ? elt.getAttribute('data-bg-pos') : '50% 50%';
				elt.style.backgroundRepeat = 'no-repeat';
				elt.style.backgroundSize = 'cover';
				elt.classList.add('compat-object-fit');
			}
		});
	}
	
	// Function to animate the scroll
	var runScrollAnimation;
	var smoothScroll = function (anchor, duration) {
		// Calculate how far and how fast to scroll
		var startLocation = window.pageYOffset;
		var endLocation = anchor.getBoundingClientRect().top + startLocation;
		var distance = endLocation - startLocation;
		var increments = distance/(duration/16);
		var checkAnimation;
		var w = window,
			d = document,
			e = d.documentElement,
			g = d.getElementsByTagName('body')[0];

		// Scroll the page by an increment, and check if it's time to stop
		var animateScroll = function () {
			window.scrollBy(0, increments);
			runScrollAnimation = requestAnimationFrame(animateScroll);
			checkAnimation();
		};
		var travelled;
		var docHeight = Math.max(g.scrollHeight, e.scrollHeight, g.offsetHeight, e.offsetHeight, g.clientHeight, e.clientHeight);
		var windowHeight = w.innerHeight||e.clientHeight||g.clientHeight;
		// If scrolling down
		if ( increments >= 0 ) {
			// Stop animation when you reach the anchor OR the bottom of the page
			checkAnimation = function () {
				travelled = window.pageYOffset;
				if ( (travelled >= (endLocation - increments)) || ((windowHeight + travelled) >= docHeight) ) {
					cancelAnimationFrame(runScrollAnimation);
					window.scrollTo(0, endLocation);
					scrollingFromClick = false;
				}
			};
		}
		// If scrolling up
		else {
			// Stop animation when you reach the anchor OR the top of the page
			checkAnimation = function () {
				travelled = window.pageYOffset;
				if ( travelled <= (endLocation + increments || 0) ) {
					cancelAnimationFrame(runScrollAnimation);
					window.scrollTo(0, endLocation);
					scrollingFromClick = false;
				}
			};
		}
		// Loop the animation function
		runScrollAnimation = requestAnimationFrame(animateScroll);
	};
	
	//adapt background-image mobile/desktop
	var ex, to,
	currentsize = 'mobile';
	function adapteBgs() {
		if (windowWidth > 1000) {
			if (currentsize == 'desktop') {
				return
			}
			currentsize = 'desktop';
		} else {
			if (currentsize == 'mobile') {
				return
			}
			currentsize = 'mobile';
		}

		if (currentsize == 'desktop') {
			ex = 'mobile';
			to = 'desktop';
		} else {
			ex = 'desktop';
			to = 'mobile';
		}
		document.querySelectorAll('[data-responsive="true"]').forEach(function(elt){
			var bgi = elt.style.backgroundImage;
			var nioubgi = bgi.replace(ex, to);
			elt.style.backgroundImage = nioubgi;
		});
	}
	adapteBgs();
	window.addEventListener('resizeEnd', function() {
		//console.log("resizeEnd");
		handleResize();
	});
	
	// generic window resize listener event
	function handleResize() {
		windowHeight = w.innerHeight||e.clientHeight||g.clientHeight;
		windowWidth = w.innerWidth||e.clientWidth||g.clientWidth;
		adapteBgs();
	}
	
});

//-------------- GENERIC FUNCTIONS AND POLYFILLS
if (!NodeList.prototype.forEach) {
	NodeList.prototype.forEach = Array.prototype.forEach;
}
if (!HTMLCollection.prototype.forEach) {
	HTMLCollection.prototype.forEach = Array.prototype.forEach;
}

//classList polyfill /for IE9)
(function () {
    if (typeof window.Element === "undefined" || "classList" in document.documentElement) return;
    var prototype = Array.prototype,
        push = prototype.push,
        splice = prototype.splice,
        join = prototype.join;
    function DOMTokenList(el) {
        this.el = el;
        // The className needs to be trimmed and split on whitespace
        // to retrieve a list of classes.
        var classes = el.className.replace(/^\s+|\s+$/g,'').split(/\s+/);
        for (var i = 0; i < classes.length; i++) {
            push.call(this, classes[i]);
        }
    };
    DOMTokenList.prototype = {
        add: function(token) {
            if(this.contains(token)) return;
            push.call(this, token);
            this.el.className = this.toString();
        },
        contains: function(token) {
            return this.el.className.indexOf(token) != -1;
        },
        item: function(index) {
            return this[index] || null;
        },
        remove: function(token) {
            if (!this.contains(token)) return;
            for (var i = 0; i < this.length; i++) {
                if (this[i] == token) break;
            }
            splice.call(this, i, 1);
            this.el.className = this.toString();
        },
        toString: function() {
            return join.call(this, ' ');
        },
        toggle: function(token) {
            if (!this.contains(token)) {
                this.add(token);
            } else {
                this.remove(token);
            }

            return this.contains(token);
        }
    };
    window.DOMTokenList = DOMTokenList;
    function defineElementGetter (obj, prop, getter) {
        if (Object.defineProperty) {
            Object.defineProperty(obj, prop,{
                get : getter
            });
        } else {
            obj.__defineGetter__(prop, getter);
        }
    }
    defineElementGetter(Element.prototype, 'classList', function () {
        return new DOMTokenList(this);
    });
})();

/*
	RequestAnimationFrame Polyfill
	http://paulirish.com/2011/requestanimationframe-for-smart-animating/
	http://my.opera.com/emoller/blog/2011/12/20/requestanimationframe-for-smart-er-animating
	by Erik Möller, fixes from Paul Irish and Tino Zijdel
	MIT license
 */ 
(function() {
	var lastTime = 0;
	var vendors = ['ms', 'moz', 'webkit', 'o'];
	for(var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
		window.requestAnimationFrame = window[vendors[x]+'RequestAnimationFrame'];
		window.cancelAnimationFrame = window[vendors[x]+'CancelAnimationFrame'] || window[vendors[x]+'CancelRequestAnimationFrame'];
	}
	if (! window.requestAnimationFrame) {
		window.requestAnimationFrame = function(callback, element) {
			var currTime = new Date().getTime();
			var timeToCall = Math.max(0, 16 - (currTime - lastTime));
			var id = window.setTimeout(function() { callback(currTime + timeToCall); }, 
			timeToCall);
			lastTime = currTime + timeToCall;
			return id;
		};
	}
	if (! window.cancelAnimationFrame) {
		window.cancelAnimationFrame = function(id) {
			clearTimeout(id);
		};
	}
}());

//is mobile
var isMobile = { 
	Android: function() { return navigator.userAgent.match(/Android/i); }, 
	BlackBerry: function() { return navigator.userAgent.match(/BlackBerry/i); }, 
	iOS: function() { return navigator.userAgent.match(/iPhone|iPad|iPod/i); }, 
	Opera: function() { return navigator.userAgent.match(/Opera Mini/i); }, 
	Windows: function() { return navigator.userAgent.match(/IEMobile/i); }, 
	any: function() { return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows()); } 
};

//triggerEvent
function triggerEvent(el, type){
   if ('createEvent' in document) {
        var e = document.createEvent('HTMLEvents');
        e.initEvent(type, false, true);
        el.dispatchEvent(e);
    }
	else {
        var e = document.createEventObject();
        e.eventType = type;
        el.fireEvent('on' + e.eventType, e);
    }
}
	
//wait until scroll is done
window.addEventListener('scroll', function() {
	if(this.scrollTO) clearTimeout(this.scrollTO);
	this.scrollTO = setTimeout(function() {
		triggerEvent(this, 'scrollEnd');
	}, 500);
}, false);
/*window.addEventListener('scrollEnd', function() {
	console.log("scrollEnd");
});*/

//wait until resize is done
window.addEventListener('resize', function() {
	if(this.resizeTO) clearTimeout(this.resizeTO);
	this.resizeTO = setTimeout(function() { 
		triggerEvent(this, 'resizeEnd');
	}, 500);
});
window.addEventListener('resizeEnd', function() {
	//console.log("resizeEnd");
	windowHeight = w.innerHeight||e.clientHeight||g.clientHeight;
	windowWidth = w.innerWidth||e.clientWidth||g.clientWidth;
});
var regExpressions = {
	'pwd': /^[a-zA-Z0-9]{5,}$/,      /* minimum 5 caractères alphanumériques */
	'zipcode' : /^[0-9]{5}$/,      /* 5 chiffres */
	'phoneNumber' : /^[0-9]{10,}$/,      /* minimum 10 chiffres */
	'integer': /^\d+$/,      /* pas de caractères alpha */
	'email': /\S+@\S+\.\S+/,      /* e-mail simplifié */
	'empty':/^\s*$/,
	//'date': /^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$/	/* dd/mm/yyy 01 à 31/01 à 12/ 1900 à 2099*/,
	'date': /^^\d{4}\-(0[1-9]|1[012])\-(0[1-9]|[12][0-9]|3[01])$/	/* yyyy-mm-dd */
}
var isEmail = function(string){
	//returns true if string is email
	return regExpressions.email.test(string);
}
var isEmpty = function(string){
	//returns true if string is empty
	return regExpressions.empty.test(string);
}
var isNumber = function(string){
	//returns true if string is a number
	return regExpressions.integer.test(string);
}
var isDate = function(string){
	//returns true if string is a number
	return regExpressions.date.test(string);
}
var w = window,
	d = document,
	e = d.documentElement,
	g = d.getElementsByTagName('body')[0];

var windowHeight = w.innerHeight||e.clientHeight||g.clientHeight;
var windowWidth = w.innerWidth||e.clientWidth||g.clientWidth;

function detectIE() {
	var ua = window.navigator.userAgent;
	// Test values; Uncomment to check result …
	// IE 10
	// ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';
	// IE 11
	// ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';
	// Edge 12 (Spartan)
	// ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';
	// Edge 13
	// ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2486.0 Safari/537.36 Edge/13.10586';
	var msie = ua.indexOf('MSIE ');
	if (msie > 0) {
		// IE 10 or older => return version number
		return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
	}

	var trident = ua.indexOf('Trident/');
	if (trident > 0) {
		// IE 11 => return version number
		var rv = ua.indexOf('rv:');
		return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
	}

	var edge = ua.indexOf('Edge/');
	if (edge > 0) {
		// Edge (IE 12+) => return version number
		return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
	}
	// other browser
	return false;
}